Issue 116131

Summary: vcl: message unregisterDraggingDestinationHandler: sent to freed object
Product: gsl Reporter: Stephan Bergmann <stephan.bergmann.secondary>
Component: codeAssignee: Stephan Bergmann <stephan.bergmann.secondary>
Status: CLOSED FIXED QA Contact: issues@gsl <issues>
Severity: Trivial    
Priority: P3 CC: issues
Version: DEV300m95   
Target Milestone: 3.4.0   
Hardware: Mac   
OS: Mac OS X 10   
Issue Type: DEFECT Latest Confirmation in: ---
Developer Difficulty: ---
Attachments:
Description Flags
tentative solution none

Description Stephan Bergmann 2010-12-15 10:58:46 UTC
On DEV300_m95 based CWS sb135, unxmacxi non-pro and unxmacxi.pro, executing
subsequenttests relatively often (2 out of 5 times) fails, in apparently
arbitrary tests (e.g., starmath/qa/unoapi and sd/qa/unoapi) during OOo shutdown
with a stderr message like

objc[34214]: FREED(id): message unregisterDraggingDestinationHandler: sent to
freed object=0x1868f480

and the relevant stack at

#0  0x95fddbfa in _objc_error ()
#1  0x95fddc30 in _objc_error ()
#2  0x95fdc637 in _objc_flush_caches ()
#3  0x021268c4 in DropTarget::~DropTarget ()
#4  0x0063205e in cppu::WeakComponentImplHelperBase::release ()
#5  0x02048849 in Window::~Window ()
#6  0x01fa2b63 in ImplBorderWindow::~ImplBorderWindow ()
#7  0x02048157 in Window::~Window ()
#8  0x0205b81f in WorkWindow::~WorkWindow ()
#9  0x015534b7 in VCLXDevice::DestroyOutputDevice ()
#10 0x01578b18 in VCLXWindow::dispose ()
#11 0x1910b2ae in framework::Frame::impl_disposeContainerWindow ()
#12 0x1911aab2 in framework::Frame::dispose ()
#13 0x1911b0fd in framework::Frame::close ()
#14 0x190ee930 in framework::Desktop::impl_closeFrames ()
#15 0x190f1bee in framework::Desktop::terminate ()
#16 0x047c4d22 in (anonymous namespace)::callVirtualMethod ()
#17 0x047c50f0 in (anonymous namespace)::cpp_call ()
#18 0x047c593f in bridges::cpp_uno::shared::unoInterfaceProxyDispatch ()
#19 0x180f92d6 in binaryurp::IncomingRequest::execute_throw ()
#20 0x180fa206 in binaryurp::IncomingRequest::execute ()
#21 0x180fcad3 in request ()
#22 0x0073f658 in cppu_threadpool::JobQueue::enter ()
#23 0x0073fe73 in cppu_threadpool::ORequestThread::run ()
#24 0x007401e8 in cppu_requestThreadWorker ()
#25 0x001ff23c in osl_thread_start_Impl ()
#26 0x974b6155 in _pthread_start ()
#27 0x974b6012 in thread_start ()

while the main stack is still idling in the event loop at

#0  0x97485266 in mach_msg_trap ()
#1  0x9748ca5c in mach_msg ()
#2  0x90932e7e in CFRunLoopRunSpecific ()
#3  0x90933aa8 in CFRunLoopRunInMode ()
#4  0x902352ac in BlockUntilNextEventMatchingListInMode ()
#5  0x902350c5 in BlockUntilNextEventMatchingListInMode ()
#6  0x90234f39 in BlockUntilNextEventMatchingListInMode ()
#7  0x94d5b6d5 in _DPSNextEvent ()
#8  0x94d5af88 in _NSUpdateMenuRefWithChangedMenuItem ()
#9  0x021160f5 in AquaSalInstance::Yield ()
#10 0x01e2216c in Application::Yield ()
#11 0x01e2224f in Application::Execute ()
#12 0x000d54a7 in desktop::Desktop::Main ()
#13 0x01e290af in ImplSVMain ()
#14 0x0211641a in AquaSalInstance::handleAppDefinedEvent ()
#15 0x02119b8e in -[VCL_NSApplication sendEvent:] ()
#16 0x94d53fe7 in _NSSetViewMultiClipDrawingHelper ()
#17 0x94d211d8 in NSApplicationMain ()
#18 0x02116798 in ImplSVMainHook ()
#19 0x01e29169 in SVMain ()
#20 0x000f356e in soffice_main ()
#21 0x00001f0e in main ()

(and there is no other relevant thread)
Comment 1 philipp.lohmann 2011-02-08 14:33:41 UTC
Resetting target accroding to new task handling scheme announced here:

http://blogs.sun.com/ratte/entry/some_changes_for_the_openoffice
Comment 2 philipp.lohmann 2011-02-08 18:27:05 UTC
Created attachment 75797 [details]
tentative solution
Comment 3 philipp.lohmann 2011-02-08 18:29:05 UTC
Alas I have not been able to reproduce this one. However this looks similar to
issue 111706 and I have attached with an analogous "solution". Could you try if
this problem a) still exists and b) might be solved (worked around) by the
attached patch ?
Comment 4 Stephan Bergmann 2011-02-09 14:53:34 UTC
@pl:  On DEV300_m98 based CWS sb138, unxmacxi non-pro, repeatedly executing
starmath/qa/unoapi produced the described failure in the 25th round, while with
the attached i116131.patch applied, it ran 150 rounds without problems (at which
time I stopped it manually).  So, seems the patch indeed fixes the problem.
Comment 5 philipp.lohmann 2011-02-09 14:58:57 UTC
your patience is greater than mine, I tried only ten times in a row. Ok, so I'll
commit the patch. Thank you for reproducing this !
Comment 6 philipp.lohmann 2011-02-25 10:45:19 UTC
please verify in CWS vcl119

changeset at http://hg.services.openoffice.org/cws/vcl119/rev/be53207856bf